from pathlib import Path
import unittest

from edgetpu_utils.partition import (
    partition_with_layer_idxs,
)
from edgetpu_utils.tflite_utils import get_num_ops


class TestPartition(unittest.TestCase):
    @classmethod
    def setUpClass(cls):
        super(TestPartition, cls).setUpClass()
        cls.model_path_1 = Path("model/mobilenet_v2_1.0_224_inat_bird_quant.tflite")
        cls.model_path_2 = Path("model/efficientnet-edgetpu-S_quant.tflite")
        cls.model_path_3 = Path("model/efficientnet-edgetpu-M_quant.tflite")
        cls.model_path_4 = Path("model/efficientnet-edgetpu-L_quant.tflite")

    @classmethod
    def tearDownClass(cls):
        super(TestPartition, cls).tearDownClass()

    def setUp(self):
        pass

    def tearDown(self):
        pass

    def test_set_up(self):
        pass

    def test_partition_with_layer_idxs_start_0(self):
        model = self.model_path_1
        num_ops = get_num_ops(model)
        segment_path = partition_with_layer_idxs(self.model_path_1, num_ops, 0, 10)
        print(segment_path)

    def test_partition_with_layer_idxs_normal(self):
        model = self.model_path_1
        num_ops = get_num_ops(model)
        segment_path = partition_with_layer_idxs(self.model_path_1, num_ops, 10, 19)
        print(segment_path)

    def test_partition_with_layer_idxs_end_last(self):
        model = self.model_path_1
        num_ops = get_num_ops(model)
        segment_path = partition_with_layer_idxs(
            self.model_path_1, num_ops, 10, num_ops - 1
        )
        print(segment_path)


if __name__ == "__main__":
    unittest.main()
